
public class SimObjectMonster implements SimObject {

    private final World world;
    private final Coords pose;
    private final int STEP = 2;

    enum Direction {

        LEFT, RIGHT
    };
    Direction direction;

    public SimObjectMonster(World world, int x, int y) {
        this.world = world;
        pose = new Coords(x, y);
        direction = Direction.RIGHT;
    }

    @Override
    public Coords getPosition() {
        return pose;
    }

    @Override
    public void doStep() {
        int x = pose.getX();
        switch (direction) {
            case LEFT:
                if (x > 20) {
                    x -= STEP;
                } else {
                    direction = Direction.RIGHT;
                }
                break;
            case RIGHT:
                if (x < (world.getDimension().getWidth() - 20)) {
                    x += STEP;
                } else {
                    direction = Direction.LEFT;
                }
                break;
        }
        pose.setX(x);
    }
}
